/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem B. Blind Problem Solving                               */
/*                                                                */
/* Original idea         Maxim Buzdalov                           */
/* Problem statement     Maxim Buzdalov                           */
/* Test set              Maxim Buzdalov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Maxim Buzdalov                           */
/******************************************************************/

import java.io.*;
import java.util.*;

public class blind_buzdalov {
    static final String A = "accept";
    static final String D = "decline";
    static final String S = "stop";

    static int solve(int c, int[] weights) {
        int optA = 0;
        int optV = 0;
        int n = weights.length;
        for (int mask = 0; mask < 1 << n; ++mask) {
            int sum = 0;
            for (int i = 0; i < n; ++i) {
                if (((mask >>> i) & 1) == 1) {
                    sum += weights[i];
                }
            }
            if (sum > optV && sum <= c) {
                optA = mask;
                optV = sum;
            }
        }
        return optA;
    }

    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int c = in.nextInt();

        int curr = in.nextInt();
        System.out.println(A);

        //Running down to 0
        while (curr > 0) {
            int next = in.nextInt();
            if (next < curr) {
                System.out.println(A);
                curr = next;
            } else {
                System.out.println(D);
            }
        }

        //Determining weights. 
        //Postcondition: everything is 111...1
        int[] weights = new int[n];
        for (int i = 0; i < n; ++i) {
            int next;
            while ((next = in.nextInt()) < curr) {
                System.out.println(D);
            }
            System.out.println(A);
            weights[i] = next - curr;
            curr = next;
        }

        int optimal = solve(c, weights);
        int mask = (1 << n) - 1;

        if (mask == optimal) {
            in.nextInt();
            System.out.println(A);
            while (in.nextInt() != curr) {
                System.out.println(D);
            }
            System.out.println(S);
        }

        while (mask != optimal) {
            int next = in.nextInt();
            if (curr > next) {
                int diff = curr - next;
                int found = 0;
                for (int i = 0; i < n; ++i) {
                    if (((mask ^ optimal) & (1 << i)) != 0 && weights[i] == diff) {
                        found = 1 << i;
                        break;
                    }
                }
                if (found != 0) {
                    curr = next;
                    mask ^= found;
                    System.out.println(mask == optimal ? S : A);
                } else {
                    System.out.println(D);
                }
            } else {
                System.out.println(D);
            }
        }

        in.close();
    }
}

