/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem C. Caravan Robbers                                     */
/*                                                                */
/* Original idea         Egor Kulikov                             */
/* Problem statement     Egor Kulikov                             */
/* Test set              Egor Kulikov                             */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.*;
import java.util.*;

public class caravan_gk {
    static Scanner in;
    static PrintWriter out;
    public static final int MAX_C = 1000000;

    class Segment implements Comparable<Segment> {
        int a, b;

        Segment(int a, int b) {
            this.a = a;
            this.b = b;
        }

//        @Override
        public int compareTo(Segment that) {
            return this.b - that.b;
        }
    }

    void run() {
        int n = in.nextInt();
        Segment[] segments = new Segment[n];
        for (int i = 0; i < segments.length; i++) {
            segments[i] = new Segment(in.nextInt(), in.nextInt());
        }
        Arrays.sort(segments);

        double l = 0;
        double r = MAX_C;
        for (int i = 0; i < 100; i++) {
            double m = (l + r) / 2;
            double start = 0;
            boolean ok = true;
            for (Segment segment : segments) {
                start = Math.max(start, segment.a) + m;
                ok &= start <= segment.b;
            }
            if (ok) {
                l = m;
            } else {
                r = m;
            }
        }

        double best = Double.MAX_VALUE;
        long bestNum = 0;
        long bestDen = 0;
        for (long den = 1; den <= n; den++) {
            long num = Math.round(r * den);
            if (best > Math.abs(r - num / (double) den)) {
                best = Math.abs(r - num / (double) den);
                bestNum = num;
                bestDen = den;
            }
        }
        out.println(bestNum + "/" + bestDen);
    }

    static class Scanner {
        final BufferedReader reader;
        StringTokenizer tokenizer = new StringTokenizer("");

        public Scanner(File file) throws FileNotFoundException {
            reader = new BufferedReader(new FileReader(file));
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public String next() {
            while (!tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new AssertionError();
                }
            }
            return tokenizer.nextToken();
        }

        public void close() {
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("caravan.in"));
        out = new PrintWriter("caravan.out");

        new caravan_gk().run();

        in.close();
        out.close();
    }
}

