/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem G. Great Deceiver                                      */
/*                                                                */
/* Original idea         Elana Kryuchkova                         */
/* Problem statement     Dmitry Gozman                            */
/* Test set              Dmitry Gozman                            */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Dmitry Gozman                            */
/******************************************************************/

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.StringTokenizer;


public class great_dg implements Runnable {
	
	private void solve() throws IOException {
		long n = in.nextLong();
		int k = in.nextInt();
		
		long[] r = new long[100];
		int c = 0;
		long pow = 1;
		while (n > 0) {
			r[c++] = n % k;
			n /= k;
			if (c % 2 == 0) {
				pow *= k;
			}
		}
		
		long result = 0;
		for (int i = c - 1; i >= 0; i--) {
			if (i % 2 == 0) {
				result += pow * r[i];
				if (i == 0) {
					result += pow;
				}
			} else {
				if (r[i] > 0) {
					result += pow;
					break;
				}
				pow /= k;
			}
		}
		
		out.println(result);
	}

	public static void main(String[] args) {
		new Thread(new great_dg()).start();
	}

	public void run() {
		try {
			in = new FastScanner(new FileReader("great.in"));
			out = new PrintWriter(new File("great.out"));
			
			solve();
			
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	PrintWriter out;
	FastScanner in;
	
	class FastScanner {
		
		BufferedReader reader;
		StringTokenizer st;

		public FastScanner(Reader reader) {
			this.reader = new BufferedReader(reader);
			st = null;
		}
		
		String next() throws IOException {
			while (st == null || !st.hasMoreTokens()) {
				st = new StringTokenizer(reader.readLine());
			}
			return st.nextToken();
		}
		
		int nextInt() throws NumberFormatException, IOException {
			return Integer.parseInt(next());
		}

		long nextLong() throws NumberFormatException, IOException {
			return Long.parseLong(next());
		}
		
		double nextDouble() throws NumberFormatException, IOException {
			return Double.parseDouble(next());
		}

		String nextLine() throws IOException {
			st = null;
			return reader.readLine();
		}
	}

}

