/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem H. Hyperdrome                                          */
/*                                                                */
/* Original idea         Vitaliy Aksenov                          */
/* Problem statement     Vitaliy Aksenov                          */
/* Test set              Vitaliy Aksenov                          */
/******************************************************************/
/* Tests                                                          */
/*                                                                */
/* Author                Vitaliy Aksenov                          */
/******************************************************************/

import java.io.*;
import java.util.*;

public class Tests {
    static final int MAXL = 300000;
    static final int AVGL = 100;
    static final int sigma = 52;
    static int tests = 1;
    static Random rnd = new Random(239);

    static int[] string = new int[MAXL];

    public static void writeTest(String test) throws IOException {
      System.out.println("Writing " + tests + " test!");
      PrintWriter out = new PrintWriter(String.format("tests/%02d", tests++));
      out.println(test);
      out.close();
    }

    public static void writeTest(int len) throws IOException {
      System.out.println("Writing " + tests + " test!");
      PrintWriter out = new PrintWriter(String.format("tests/%02d", tests++));
      out.println(len);
      for (int i = 0; i < len; i++) {
        if (string[i] > 26) {
          out.print((char)(string[i] - 27 + 'A'));
        } else {
          out.print((char)(string[i] - 1 + 'a'));
        }
      }
      out.println();
      out.close();
    }

    public static void genOneChar(int len) throws IOException {
      int c = rnd.nextInt(sigma) + 1;
      for (int i = 0; i < len; i++) {
        string[i] = c;
      }
      writeTest(len);
    }

    public static void genByPairs(int len) throws IOException {
      for (int i = 0; i < len; i += 2) {
        string[i] = rnd.nextInt(sigma) + 1;
        string[i + 1] = string[i];
      }
      writeTest(len);
    }

    public static void genRandom(int len) throws IOException {
      for (int i = 0; i < len; i++) {
        string[i] = rnd.nextInt(sigma) + 1;
      }
      writeTest(len);
    }

    public static void main(String[] args) throws IOException {
        File dir = new File("tests");
        if (!dir.exists()) {
            dir.mkdir();
        }

        writeTest("3\naaa");
        writeTest("7\nabadaba");
        writeTest("3\naAA");

        writeTest("1\na");
        writeTest("1\nZ");
        writeTest("2\nZZ");
        writeTest("7\nabadabb");

        for (int i = 0; i < 4; i++) {
          genOneChar(rnd.nextInt(AVGL) + 1);
          genByPairs(rnd.nextInt(AVGL) + 1);
          genRandom(rnd.nextInt(AVGL) + 1);
        }

        for (int i = 0; i < 7; i++) {
          genOneChar(rnd.nextInt(MAXL) + 1);
          genByPairs(rnd.nextInt(MAXL) + 1);
          genRandom(rnd.nextInt(MAXL) + 1);
        }

        for (int i = 0; i < 3; i++) {
          genOneChar(MAXL);
          genByPairs(MAXL);
          genRandom(MAXL);
        }
    }
}
