/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem H. Hyperdrome                                          */
/*                                                                */
/* Original idea         Vitaliy Aksenov                          */
/* Problem statement     Vitaliy Aksenov                          */
/* Test set              Vitaliy Aksenov                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Vitaliy Aksenov                          */
/******************************************************************/

import java.io.*;
import java.util.*;

public class hyperdrome_va implements Runnable {
	public static void main(String[] args) {
		new Thread(new hyperdrome_va()).run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public void solve() throws IOException {
		int n = nextInt();

		long[] hashs = new long[n + 1];
		char[] c = nextToken().toCharArray();
		for (int i = 0; i < c.length; i++) {
			if (c[i] <= 'Z') {
				c[i] = (char) (c[i] - 'A' + 26);
			} else {
				c[i] = (char) (c[i] - 'a');
			}
			hashs[i + 1] = hashs[i] ^ (1L << c[i]);
		}

		Arrays.sort(hashs);

		long ans = 0;
		long z = 1;
		for (int i = 1; i < hashs.length; i++) {
			if (hashs[i] != hashs[i - 1]) {
				ans += z * (z - 1) / 2;
				z = 0;
			}
			z++;
		}

		ans += z * (z - 1) / 2;

		int i0, i1;
		long c0, c1, l0, l1;
		for (int b = 0; b < 52; b++) {
			long bit = 1L << b;
			i0 = 0;
			i1 = 0;
			c0 = 1;
			c1 = 0;
			l0 = -1;
			l1 = 0;
			while (i0 < n + 1 || i1 < n + 1) {
				if ((l0 | bit) < l1) {
					while (i0 < n + 1 && (hashs[i0] & bit) != 0) {
						i0++;
					}
					if (i0 == n + 1) {
						break;
					}
					l0 = hashs[i0];
					c0 = 0;
					while (i0 < n + 1 && hashs[i0] == l0) {
						i0++;
						c0++;
					}
				} else {
					while (i1 < n + 1 && (hashs[i1] & bit) == 0) {
						i1++;
					}
					if (i1 == n + 1) {
						break;
					}
					l1 = hashs[i1];
					c1 = 0;
					while (i1 < n + 1 && hashs[i1] == l1) {
						i1++;
						c1++;
					}
				}
				if (l0 != l1 && (l0 | bit) == l1) {
					ans += c0 * c1;
				}
			}
		}

		out.println(ans);
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("hyperdrome.in"));
			out = new PrintWriter("hyperdrome.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}

