/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem K. Kingdom Reunion                                     */
/*                                                                */
/* Original idea         Maxim Buzdalov                           */
/* Problem statement     Maxim Buzdalov                           */
/* Test set              Maxim Buzdalov                           */
/******************************************************************/
/* Tests                                                          */
/*                                                                */
/* Author                Maxim Buzdalov                           */
/******************************************************************/

import java.io.*;
import java.util.*;

public class Tests {
    static final int MAX_VERTICES = 10000;
    static final int MAX_COORD = 100000;

    public static void main(String[] args) {
        rmrf(root);
        root.mkdir();

        write("Sample", l(p(0, 0), p(2, 0), p(1, 1)), l(p(0, 0), p(2, 0), p(1, -1)), l(p(0, 0), p(1, 1), p(2, 0), p(1, -1)));
        write("Sample", l(p(0, 0), p(1, 1), p(0, 1), p(1, 0)), l(p(0, 0), p(0, 1), p(0, 2)), l(p(1, 2)));
        write("Sample", l(p(0, 2), p(1, 0), p(2, 2)), l(p(0, 1), p(2, 1), p(1, 3)), l(p(0, 0), p(3, 0), p(0, 3)));
        write("Sample", l(p(0, 0), p(1, 0), p(0, 1)), l(p(2, 0), p(3, 0), p(2, 1)), l(p(4, 0), p(5, 0), p(4, 1)));
        write("Equal points", l(p(0, 0)), l(p(0, 0)), l(p(0, 0)));
        write("Different points", l(p(0, 0)), l(p(1, 0)), l(p(2, 0)));
        write("Different points", l(p(0, 0)), l(p(1, 0)), l(p(0, 0)));
        write("Different points", l(p(0, 0)), l(p(0, 0)), l(p(2, 0)));
        write("Equal lines", l(p(0, 0), p(1, 0)), l(p(0, 0), p(1, 0)), l(p(0, 0), p(1, 0)));
        write("Different lines", l(p(0, 0), p(1, 0)), l(p(1, 0), p(2, 0)), l(p(0, 0), p(2, 0)));
        write("Multilines", l(p(0, 0), p(1, 0), p(2, 0)), l(p(1, 0), p(2, 0), p(3, 0)), l(p(0, 0), p(2, 0), p(3, 0)));
        write3("Simple square test", l(p(0, 0), p(1, 0), p(1, 1)), l(p(0, 0), p(0, 1), p(1, 1)), l(p(0, 0), p(0, 1), p(1, 1), p(1, 0)));
        write3("Square test with a middle point on both", l(p(0, 0), p(2, 0), p(2, 2), p(1, 1)), l(p(1, 1), p(2, 2), p(0, 2), p(0, 0)), l(p(0, 0), p(2, 0), p(2, 2), p(0, 2)));
        write3("Square test with a middle point on first", l(p(0, 0), p(2, 0), p(2, 2), p(1, 1)), l(p(2, 2), p(0, 2), p(0, 0)), l(p(0, 0), p(2, 0), p(2, 2), p(0, 2)));
        write3("Square test with extra points on union", l(p(0, 0), p(2, 0), p(2, 2)), l(p(2, 2), p(0, 2), p(0, 0)), l(p(0, 0), p(1, 0), p(2, 0), p(2, 1), p(2, 2), p(1, 2), p(0, 2), p(0, 1)));
        write3("Square test with different middle points", l(p(0, 0), p(3, 0), p(3, 3), p(2, 2)), l(p(0, 0), p(0, 3), p(3, 3), p(1, 1)), l(p(0, 0), p(0, 3), p(3, 3), p(3, 0)));
        write3("Square test with different extra points on all", l(p(0, 0), p(0, 2), p(1, 2), p(2, 2)), l(p(0, 0), p(1, 0), p(2, 0), p(2, 2)), l(p(0, 0), p(2, 0), p(2, 1), p(2, 2), p(0, 2), p(0, 1)));
        write3("Union is not really a polygon",
              l(p(0, 0), p(0, 5), p(3, 5), p(2, 3), p(4, 0)),
              l(p(4, 0), p(8, 0), p(8, 5), p(5, 5), p(6, 3)),
              l(p(0, 0), p(8, 0), p(8, 5), p(5, 5), p(6, 3), p(4, 0), p(2, 3), p(3, 5), p(0, 5)));
        write3("A and B intersect by segments", l(p(0, 1), p(3, 1), p(2, 0), p(0, 0)), l(p(2, 0), p(4, 0), p(4, 1), p(1, 1)), l(p(0, 0), p(4, 0), p(4, 1), p(0, 1)));
        write3("A and B intersect not by segments", l(p(0, 0), p(2, 0), p(3, 1), p(2, 2), p(0, 2)), l(p(4, 0), p(2, 0), p(1, 1), p(2, 2), p(4, 2)), l(p(0, 0), p(4, 0), p(4, 2), p(0, 2)));
        write3("A and B intersect by segments, with no points of one inside another",
              l(p(1, 0), p(2, 0), p(2, 3), p(1, 3)),
              l(p(0, 1), p(0, 2), p(3, 2), p(3, 1)),
              l(p(0, 1), p(1, 1), p(1, 0), p(2, 0), p(2, 1), p(3, 1), p(3, 2), p(2, 2), p(2, 3), p(1, 3), p(1, 2), p(0, 2)));
        write3("A and B intersect by segments, with no points of one inside another",
              l(p(1, 0), p(2, 0), p(2, 3), p(1, 3)),
              l(p(0, 1), p(0, 2), p(3, 2), p(3, 1)),
              l(p(0, 0), p(3, 0), p(3, 3), p(0, 3)));
        write3("Perfect match of inner broken lines", l(p(0, 0), p(2, 0), p(3, 1), p(2, 2), p(0, 2)), l(p(4, 0), p(2, 0), p(3, 1), p(2, 2), p(4, 2)), l(p(0, 0), p(4, 0), p(4, 2), p(0, 2)));
        write3("Subtraction, not addition", l(p(0, 0), p(2, 0), p(2, 1), p(0, 1)), l(p(0, 0), p(1, 0), p(1, 1), p(0, 1)), l(p(1, 0), p(1, 1), p(2, 1), p(2, 0)));
        write3("Three equal squares", l(p(0, 0), p(1, 0), p(1, 1), p(0, 1)), l(p(0, 0), p(1, 0), p(1, 1), p(0, 1)), l(p(0, 0), p(1, 0), p(1, 1), p(0, 1)));
        write3("2 strictly inside 1", l(p(0, 0), p(3, 0), p(3, 3), p(0, 3)), l(p(1, 1), p(2, 1), p(2, 2), p(1, 2)), l(p(0, 0), p(3, 0), p(3, 3), p(0, 3)));
        write3("1 strictly inside 2", l(p(1, 1), p(2, 1), p(2, 2), p(1, 2)), l(p(0, 0), p(3, 0), p(3, 3), p(0, 3)), l(p(0, 0), p(3, 0), p(3, 3), p(0, 3)));
        write3("2 strictly inside 1 with common vertices", l(p(4, 4), p(0, 3), p(1, 1), p(5, 1)), l(p(5, 1), p(0, 3), p(4, 3)), l(p(5, 1), p(3, 2), p(0, 3), p(3, 3)));

        //Tests by brute force
        write3("Brute force anti-re", l(p(5, 5), p(3, 7), p(8, 3), p(9, 3), p(2, 0)),
                                      l(p(9, 3), p(6, 5), p(6, 2), p(5, 5), p(8, 3), p(5, 7)),
                                      l(p(1, 4), p(6, 2), p(6, 5), p(9, 3), p(3, 7), p(5, 7), p(5, 5), p(2, 0)));
        write3("Brute force anti-re", l(p(2, 0), p(0, 1), p(2, 6), p(4, 8), p(7, 7), p(8, 0)),
                                      l(p(0, 1), p(5, 3), p(2, 6), p(2, 0)),
                                      l(p(2, 0), p(8, 5), p(4, 8), p(7, 7), p(8, 0)));
        write3("Brute force anti-re", l(p(7, 9), p(9, 8), p(0, 0), p(9, 1), p(4, 2), p(4, 8), p(8, 7), p(8, 9)),
                                      l(p(8, 9), p(9, 1), p(7, 0), p(0, 0), p(7, 9)),
                                      l(p(4, 5), p(0, 0), p(7, 9), p(7, 0), p(8, 7), p(9, 1), p(9, 8), p(8, 9), p(4, 2)));
        write3("Brute force anti-re", l(p(3, 5), p(3, 6), p(5, 8), p(8, 0), p(5, 2), p(1, 9), p(8, 2)),
                                      l(p(4, 9), p(5, 2), p(3, 5), p(8, 0), p(3, 6), p(8, 1), p(8, 2)),
                                      l(p(5, 0), p(3, 6), p(8, 2), p(4, 9), p(1, 9)));
        write3("Brute force anti-re", l(p(4, 3), p(2, 4), p(2, 1)),
                                      l(p(2, 4), p(2, 2), p(1, 0)),
                                      l(p(3, 3), p(2, 4), p(0, 5), p(1, 0)));
        write3("Brute force anti-re", l(p(3, 2), p(1, 4), p(2, 0)),
                                      l(p(2, 0), p(3, 2), p(0, 5), p(4, 2)),
                                      l(p(2, 3), p(5, 3), p(4, 2), p(5, 1), p(1, 0), p(1, 4)));
        write3("Brute force anti-re", l(p(2, 2), p(4, 3), p(4, 0)),
                                      l(p(0, 5), p(5, 3), p(3, 3)),
                                      l(p(5, 0), p(0, 5), p(5, 3)));
        write3("Brute force anti-buzdalov_wa_3", l(p(6, 2), p(0, 8), p(4, 0)),
                                                 l(p(6, 4), p(5, 5), p(6, 2), p(7, 9), p(1, 7), p(4, 9)),
                                                 l(p(1, 7), p(4, 0), p(0, 8), p(6, 2)));
        write3("Brute force anti-buzdalov_wa_3", l(p(1, 0), p(1, 3), p(4, 2), p(3, 2), p(5, 4), p(2, 0), p(3, 1), p(2, 2)),
                                                 l(p(1, 0), p(2, 0), p(2, 2), p(3, 2), p(1, 1), p(1, 3)),
                                                 l(p(4, 2), p(3, 2), p(4, 4), p(2, 0), p(1, 0), p(5, 4), p(1, 3), p(1, 1), p(3, 1)));
        write3("Brute force anti-buzdalov_wa_3", l(p(1, 5), p(0, 2), p(2, 4), p(4, 4), p(5, 2), p(4, 3)),
                                                 l(p(2, 0), p(1, 2), p(2, 4)),
                                                 l(p(2, 0), p(5, 2), p(0, 2), p(2, 4), p(1, 3)));
        write3("Brute force anti-buzdalov_wa_3", l(p(5, 4), p(4, 0), p(2, 5), p(4, 1), p(2, 3), p(5, 1)),
                                                 l(p(4, 1), p(3, 0), p(5, 2), p(0, 5)),
                                                 l(p(2, 3), p(4, 1), p(0, 5), p(3, 0), p(4, 0), p(5, 2), p(2, 5)));
        write3("Brute force anti-buzdalov_wa_2", l(p(4, 3), p(2, 2), p(0, 2), p(0, 1), p(0, 0)),
                                                 l(p(2, 2), p(0, 0), p(0, 1)),
                                                 l(p(0, 2), p(2, 2), p(0, 0)));
        write3("Brute force anti-buzdalov_wa_2", l(p(2, 1), p(0, 3), p(5, 0)),
                                                 l(p(5, 5), p(4, 5), p(2, 2)),
                                                 l(p(1, 1), p(1, 4), p(5, 5)));
        write3("Brute force anti-buzdalov_wa_2", l(p(4, 4), p(4, 3), p(1, 2), p(4, 5)),
                                                 l(p(0, 3), p(1, 2), p(3, 2), p(4, 3), p(5, 5), p(4, 5), p(3, 4)),
                                                 l(p(3, 2), p(4, 3), p(5, 4), p(4, 4), p(3, 4)));
        write3("Brute force anti-buzdalov_wa_2", l(p(1, 1), p(1, 2), p(5, 5)),
                                                 l(p(3, 4), p(1, 2), p(2, 2), p(5, 5)),
                                                 l(p(0, 2), p(1, 2), p(4, 2), p(1, 4)));
        write3("Brute force anti-everything", l(p(1, 3), p(0, 3), p(1, 5)),
                                              l(p(1, 4), p(1, 5), p(4, 5), p(1, 1), p(2, 4)),
                                              l(p(4, 5), p(0, 2), p(1, 5), p(1, 4), p(1, 3)));
        write3("Brute force anti-everything", l(p(1, 1), p(5, 3), p(4, 2)),
                                              l(p(4, 4), p(3, 2), p(2, 3)),
                                              l(p(2, 3), p(4, 4), p(1, 1), p(2, 1), p(5, 3), p(5, 5)));
        write3("Brute force anti-buzdalov_wa_5", l(p(3, 1), p(3, 3), p(5, 4)),
                                                 l(p(3, 1), p(5, 4), p(5, 2)),
                                                 l(p(0, 2), p(5, 4), p(3, 1)));
        write3("Brute force anti-gk", l(p(12, 4), p(9, 8), p(3, 0), p(12, 12)),
                                      l(p(5, 7), p(8, 0), p(3, 0), p(4, 7), p(12, 4), p(3, 6), p(5, 10), p(11, 6), p(13, 8), p(8, 11), p(7, 14), p(13, 9)),
                                      l(p(5, 7), p(10, 0), p(12, 12), p(9, 8), p(13, 8), p(10, 10), p(9, 6)));
        write3("Brute force anti-gk", l(p(14, 1), p(13, 1), p(0, 0), p(8, 7), p(3, 7), p(5, 12), p(9, 8), p(12, 1)),
                                      l(p(13, 2), p(14, 1), p(10, 13), p(14, 3), p(0, 5), p(0, 0), p(11, 11), p(0, 12), p(4, 0), p(11, 5)),
                                      l(p(0, 5), p(14, 1), p(5, 12), p(11, 5), p(8, 7), p(10, 13), p(12, 1), p(9, 8), p(11, 3), p(13, 1), p(5, 11), p(11, 11), p(0, 12), p(4, 0), p(5, 6), p(1, 9), p(14, 3), p(0, 0), p(3, 7)));
        write3("Brute force anti-gk", l(p(0, 13), p(3, 4), p(5, 9), p(10, 5)),
                                      l(p(10, 3), p(14, 11), p(0, 13), p(5, 11), p(0, 12), p(2, 0), p(10, 5), p(4, 12), p(1, 4), p(0, 4), p(7, 7), p(14, 3), p(4, 4), p(14, 7), p(5, 9), p(9, 14), p(3, 4)),
                                      l(p(11, 13), p(3, 4), p(1, 4), p(11, 5), p(14, 3), p(2, 0), p(14, 7), p(10, 5)));
        write3("Brute force anti-gk", l(p(14, 10), p(4, 7), p(1, 13), p(4, 5), p(10, 5), p(5, 5), p(10, 3)),
                                      l(p(5, 5), p(13, 2), p(9, 13), p(4, 6), p(8, 9), p(10, 3), p(10, 13), p(3, 14), p(14, 10), p(1, 5), p(4, 5), p(13, 5), p(12, 3), p(1, 13), p(10, 5), p(9, 3)),
                                      l(p(1, 5), p(14, 10), p(1, 13), p(10, 13)));
        write3("Brute force anti-gk (new)", l(p(10, 6), p(5, 1), p(9, 13)),
                                            l(p(5, 9), p(10, 13), p(10, 6), p(8, 0), p(2, 6), p(9, 3)),
                                            l(p(1, 0), p(6, 13), p(14, 1), p(10, 6), p(8, 0), p(13, 8), p(5, 8), p(3, 14), p(5, 14)));
        write3("Brute force anti-gk (new)", l(p(5, 13), p(14, 0), p(4, 5), p(4, 8), p(6, 4)),
                                            l(p(12, 14), p(6, 4), p(14, 12), p(13, 7), p(8, 0), p(1, 0), p(11, 2), p(4, 12), p(9, 3), p(14, 0), p(8, 2),
                                              p(3, 13), p(7, 9)),
                                            l(p(14, 0), p(2, 2), p(11, 10), p(8, 0), p(4, 12)));
        write3("Brute force anti-gk (new)", l(p(8, 6), p(11, 14), p(10, 1), p(10, 2), p(10, 6), p(9, 5), p(0, 14), p(4, 12)),
                                            l(p(8, 6), p(12, 14), p(13, 7), p(4, 2), p(0, 10), p(9, 5), p(0, 14), p(11, 11), p(1, 10), p(11, 8)),
                                            l(p(4, 12), p(11, 8), p(6, 14), p(11, 11), p(7, 1), p(0, 9), p(4, 2), p(13, 7), p(11, 14), p(9, 5), p(0, 10), p(5, 4), p(10, 2), p(12, 14), p(0, 14), p(1, 10), p(1, 14), p(10, 6)));
        write3("Brute force anti-gk (new)", l(p(11, 9), p(5, 9), p(5, 14), p(6, 9), p(10, 11)),
                                            l(p(0, 11), p(6, 9), p(12, 5), p(7, 13), p(8, 8), p(5, 9), p(5, 14), p(6, 13), p(10, 11), p(9, 7)),
                                            l(p(9, 7), p(5, 9), p(1, 11), p(6, 4), p(6, 6), p(2, 12), p(10, 11), p(7, 13), p(6, 3), p(6, 13), p(12, 6), p(0, 11), p(11, 9), p(6, 9), p(2, 11), p(12, 5), p(0, 0), p(14, 1)));
        //Tests by brute force ends

        int[] sizes = { 1000, 10000 };
        for (int size : sizes) {
            write("Random: R, R, R", randomPoints(size),  randomPoints(size),  randomPoints(size));
            write("Random: P, R, R", randomPolygon(size), randomPoints(size),  randomPoints(size));
            write("Random: R, P, R", randomPoints(size),  randomPolygon(size), randomPoints(size));
            write("Random: R, R, P", randomPoints(size),  randomPoints(size),  randomPolygon(size));
            write("Random: P, P, R", randomPolygon(size), randomPolygon(size), randomPoints(size));
            write("Random: P, R, P", randomPolygon(size), randomPoints(size),  randomPolygon(size));
            write("Random: R, P, P", randomPoints(size),  randomPolygon(size), randomPolygon(size));
            write("Random: P, P, P", randomPolygon(size), randomPolygon(size), randomPolygon(size));
        }
        for (int size : sizes) {
            write2("Horizontal saw, match",    horzSaw(size, -MAX_COORD, -MAX_COORD, -MAX_COORD + 1, MAX_COORD - 2, MAX_COORD - 1),
                                               horzSaw(size, -MAX_COORD, -MAX_COORD + 1, -MAX_COORD + 2, MAX_COORD - 1, MAX_COORD),
                                               horzSaw(size, -MAX_COORD, -MAX_COORD, -MAX_COORD + 2, MAX_COORD - 2, MAX_COORD));
            write2("Horizontal saw, 1 = 3",    horzSaw(size, -MAX_COORD, -MAX_COORD, -MAX_COORD + 1, MAX_COORD - 2, MAX_COORD - 1),
                                               horzSaw(size, -MAX_COORD, -MAX_COORD + 1, -MAX_COORD + 2, MAX_COORD - 1, MAX_COORD),
                                               horzSaw(size, -MAX_COORD, -MAX_COORD, -MAX_COORD + 1, MAX_COORD - 2, MAX_COORD - 1));
            write2("Horizontal saw, disjoint", horzSaw(size, -MAX_COORD, -MAX_COORD, -MAX_COORD + 1, MAX_COORD - 3, MAX_COORD - 2),
                                               horzSaw(size, -MAX_COORD, -MAX_COORD + 2, -MAX_COORD + 3, MAX_COORD - 1, MAX_COORD),
                                               horzSaw(size, -MAX_COORD, -MAX_COORD, -MAX_COORD + 2, MAX_COORD - 2, MAX_COORD));
            write2("Horizontal saw, overlap",  horzSaw(size, -MAX_COORD, -MAX_COORD, -MAX_COORD + 2, MAX_COORD - 3, MAX_COORD - 1),
                                               horzSaw(size, -MAX_COORD, -MAX_COORD + 1, -MAX_COORD + 3, MAX_COORD - 2, MAX_COORD),
                                               horzSaw(size, -MAX_COORD, -MAX_COORD, -MAX_COORD + 3, MAX_COORD - 3, MAX_COORD));
            write2("Horizontal saw, inside",   horzSaw(size,     -MAX_COORD,     -MAX_COORD, -MAX_COORD + 3, MAX_COORD - 3, MAX_COORD),
                                               horzSaw(size - 8, -MAX_COORD + 2, -MAX_COORD + 1, -MAX_COORD + 2, MAX_COORD - 2, MAX_COORD - 1),
                                               horzSaw(size,     -MAX_COORD,     -MAX_COORD, -MAX_COORD + 2, MAX_COORD - 2, MAX_COORD));
            write2("Saw with rectangle inside", vsSaw(size,             -MAX_COORD, -MAX_COORD, -MAX_COORD + 1, MAX_COORD - 1, MAX_COORD),
                                                rect((size - 2) / 2, 2, -MAX_COORD + 1, -MAX_COORD + 1, MAX_COORD - 1),
                                                vsSaw(size,             -MAX_COORD, -MAX_COORD, -MAX_COORD + 1, MAX_COORD - 1, MAX_COORD));

            Point[] upSaw = new Point[size - 1];
            for (int i = 0; i < upSaw.length; ++i) {
                upSaw[i] = new Point(i, (i % 2 == 0) ? (i == 0 || i + 1 == upSaw.length ? 2 : 1) : 0);
            }
            Point[] under = new Point[size / 2 + 1];
            for (int i = 0; i + 1 < under.length; ++i) {
                under[i] = new Point(2 * i, 0);
            }
            under[under.length - 1] = new Point(0, -1);
            write2("Saw with touching rectange", upSaw, l(p(0, 0), p(size - 1, 0), p(size - 1, -1), p(0, -1)),
                                                        l(p(0, 2), p(size - 1, 2), p(size - 1, -1), p(0, -1)));
            write2("Saw with touching triangle", upSaw, under, l(p(0, 2), p(size - 1, 2), p(size - 1, -1), p(0, -1)));

            int ns = 4 * (size / 4) - 2;
            Point[] z = new Point[ns];
            for (int i = 0; i + 1 < ns; ++i) {
                z[i] = new Point(i / 2, i % 2 == 0 ? 0 : -1);
            }
            z[ns - 1] = new Point(ns / 2, 1);

            write2("Saw with triangle inside", z, l(z[0], z[ns - 2], z[ns - 1]), z);
            write2("Saw with triangle inside", l(z[0], z[ns - 2], z[ns - 1]), z, z);
        }
    }

    static int nTests = 0;
    static final File root = new File("tests");
    static final File lst = new File(root, "tests.lst");
    static final Random random = new Random(243124321);

    static final class Point implements Comparable<Point> {
        final int x, y;
        public Point(int x, int y) {
            if (x > MAX_COORD || x < -MAX_COORD || y > MAX_COORD || y < -MAX_COORD) {
                throw new AssertionError();
            }
            this.x = x;
            this.y = y;
        }
        public long vmulAround(Point l, Point r) {
            return (long) (l.x - x) * (long) (r.y - y) - (long) (l.y - y) * (long) (r.x - x);
        }
        public long smulAround(Point l, Point r) {
            return (long) (l.x - x) * (long) (r.x - x) + (long) (l.y - y) * (long) (r.y - y);
        }
        public String toString() {
            return x + " " + y;
        }
        public int hashCode() {
            return x * 31 + y * 239;
        }
        public boolean equals(Object o) {
            if (o != null && o.getClass() == Point.class) {
                Point that = (Point) (o);
                return x == that.x && y == that.y;
            } else {
                return false;
            }
        }
        public int compareTo(Point that) {
            return (x != that.x) ? x - that.x : y - that.y;
        }
    }

    static void write3(String comment, Point[] a, Point[] b, Point[] ab) {
        write2(comment, a, b, ab);
        int maxX = 0, maxY = 0;
        for (Point p : a) {
            maxX = Math.max(maxX, Math.abs(p.x));
            maxY = Math.max(maxY, Math.abs(p.y));
        }
        for (Point p : b) {
            maxX = Math.max(maxX, Math.abs(p.x));
            maxY = Math.max(maxY, Math.abs(p.y));
        }
        for (Point p : ab) {
            maxX = Math.max(maxX, Math.abs(p.x));
            maxY = Math.max(maxY, Math.abs(p.y));
        }
        int rX = MAX_COORD / maxX;
        int rY = MAX_COORD / maxY;
        Point[] na = new Point[a.length];
        Point[] nb = new Point[b.length];
        Point[] nab = new Point[ab.length];
        for (int i = 0; i < a.length; ++i) {
            na[i] = new Point(a[i].x * rX, a[i].y * rY);
        }
        for (int i = 0; i < b.length; ++i) {
            nb[i] = new Point(b[i].x * rX, b[i].y * rY);
        }
        for (int i = 0; i < ab.length; ++i) {
            nab[i] = new Point(ab[i].x * rX, ab[i].y * rY);
        }
        write2(comment + " (scaled)", na, nb, nab);
    }

    static void write2(String comment, Point[] a, Point[] b, Point[] ab) {
        writeT(comment, a, b, ab);
        int ia = random.nextInt(a.length - 1) + 1;
        int ib = random.nextInt(b.length - 1) + 1;
        int iab = random.nextInt(ab.length - 1) + 1;
        write(comment + " (shifted)", rotate(a, ia), rotate(b, ib), rotate(ab, iab));
    }

    static void writeT(String comment, Point[] a, Point[] b, Point[] ab) {
        write(comment, a, b, ab);
        write(comment + " (transposed)", transpose(a), transpose(b), transpose(ab));
    }

    static void write(String comment, Point[] a, Point[] b, Point[] ab) {
        try {
            if (a.length == 0 || a.length > MAX_VERTICES ||
                b.length == 0 || b.length > MAX_VERTICES ||
                ab.length == 0 || ab.length > MAX_VERTICES) {
                throw new AssertionError();
            }
            nTests++;

            PrintWriter log = new PrintWriter(new FileWriter(lst, true));
            log.printf("Test %03d [%d, %d, %d]: %s%n", nTests, a.length, b.length, ab.length, comment);
            log.close();

            PrintWriter out = new PrintWriter(new File(root, String.format("%03d", nTests)));
            out.println(a.length);
            for (Point p : a) {
                out.println(p);
            }
            out.println(b.length);
            for (Point p : b) {
                out.println(p);
            }
            out.println(ab.length);
            for (Point p : ab) {
                out.println(p);
            }
            out.close();
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
    }

    static Point p(int x, int y) {
        return new Point(x, y);
    }

    static Point[] l(Point... pts) {
        return pts;
    }

    static void rmrf(File f) {
        if (f.isDirectory()) {
            for (File ch : f.listFiles()) {
                rmrf(ch);
            }
        }
        f.delete();
    }

    static int randomCoord() {
        return random.nextInt(2 * MAX_COORD + 1) - MAX_COORD;
    }

    static Point randomPoint() {
        return new Point(randomCoord(), randomCoord());
    }

    static Point[] randomPoints(int size) {
        Point[] rv = new Point[size];
        for (int i = 0; i < rv.length; ++i) {
            rv[i] = randomPoint();
        }
        return rv;
    }

    static Point[] randomPolygon(int size) {
        Point[] pts = randomPoints(size);
        while (true) {
            final Point center = randomPoint();
            boolean notSame = true;
            boolean hasLess = false;
            boolean hasGreater = false;
            for (Point p : pts) {
                notSame &= !center.equals(p);
                int cmp = center.compareTo(p);
                hasLess |= cmp > 0;
                hasGreater |= cmp < 0;
            }
            if (notSame && hasLess && hasGreater) {
                Arrays.sort(pts, new Comparator<Point>() {
                    public int compare(Point l, Point r) {
                        int lh = Integer.signum(center.compareTo(l));
                        int rh = Integer.signum(center.compareTo(r));
                        if (lh != rh) {
                            return lh;
                        } else {
                            int vm = Long.signum(center.vmulAround(l, r));
                            if (vm != 0) {
                                return -vm;
                            } else {
                                return Long.signum(center.smulAround(l, l) - center.smulAround(r, r));
                            }
                        }
                    }
                });
                return pts;
            }
        }
    }

    static Point[] horzSaw(int vertices, int minX, int lowMinY, int lowMaxY, int highMinY, int highMaxY) {
        int n = vertices / 2;

        Point[] rv = new Point[2 * n];
        for (int i = 0, j = rv.length - 1; i < j; ++i, --j) {
            rv[i] = new Point(minX + i, (i % 2 == 0) ? lowMinY : highMinY);
            rv[j] = new Point(minX + i, (i % 2 == 0) ? lowMaxY : highMaxY);
        }

        return rv;
    }

    static Point[] transpose(Point[] rv) {
        for (int i = 0; i < rv.length; ++i) {
            rv[i] = new Point(rv[i].y, rv[i].x);
        }
        return rv;
    }

    static Point[] rotate(Point[] a, int step) {
        Point[] rv = new Point[a.length];
        for (int i = 0; i < rv.length; ++i) {
            rv[i] = a[(i + step) % a.length];
        }
        return rv;
    }

    static Point[] vertSaw(int vertices, int minY, int lowMinX, int lowMaxX, int highMinX, int highMaxX) {
        return transpose(horzSaw(vertices, minY, lowMinX, lowMaxX, highMinX, highMaxX));
    }

    static Point[] fromPoints(Point[] pts, int size) {
        Point[] rv = new Point[size];
        boolean[] used = new boolean[pts.length];
        for (int i = 0; i < size; ++i) {
            int index;
            do {
                index = random.nextInt(pts.length);
            } while (used[index]);
            used[index] = true;
            rv[i] = pts[index];
        }
        return rv;
    }

    static Point[] vsSaw(int vertices, int minX, int lowMinY, int lowMaxY, int highMinY, int highMaxY) {
        int n = vertices / 2;

        Point[] rv = new Point[2 * n];
        for (int i = 0, j = rv.length - 1; i < j; ++i, --j) {
            rv[i] = new Point(minX + i, (i % 2 == 0) ? lowMinY : lowMaxY);
            rv[j] = new Point(minX + i, (i % 2 == 0) ? highMaxY : highMinY);
        }

        return rv;
    }

    static Point[] rect(int vertices, int step, int minX, int minY, int maxY) {
        int n = vertices / 2;
        Point[] rv = new Point[2 * n];
        for (int i = 0, j = rv.length - 1; i < j; ++i, --j) {
            rv[i] = new Point(minX + step * i, minY);
            rv[j] = new Point(minX + step * i, maxY);
        }
        return rv;
    }
}

